set MPXPresent 1
if {[info exists env(MPXServer)]} then {set MPXServer $env(MPXServer)} \
    else {set MPXServer vme}

#    Routing table
#       index  cfd module number
#       item 1     MPX module 
#       item 2     logic input
set Routing(1)  [list MPX1 1]
set Routing(2)  [list MPX1 1]
set Routing(3)  [list MPX1 1]
set Routing(4)  [list MPX1 1]
set Routing(5)  [list MPX1 1]
set Routing(6)  [list MPX1 2]
set Routing(7)  [list MPX1 2]
set Routing(8)  [list MPX1 2]
set Routing(9)  [list MPX1 2]
set Routing(10) [list MPX1 2]
set Routing(11) [list MPX1 2]
set Routing(12) [list MPX1 2]
set Routing(13) [list MPX1 2]
set Routing(14) [list MPX1 3]
set Routing(15) [list MPX1 3]
set Routing(16) [list MPX1 4]
set Routing(17) [list MPX1 4]
set Routing(18) [list MPX1 4]
set Routing(19) [list MPX1 5]
set Routing(20) [list MPX1 5]
set Routing(21) [list MPX1 6]
set Routing(22) [list MPX1 6]
set Routing(23) [list MPX1 9]

#    register to connect multiplex signal for scope channel i
set Relay(1) rlyA0
set Relay(2) rlyA1
set Relay(3) rlyB0
set Relay(4) rlyB1


proc do_mpx {} {
    global MPXPresent

    if {$MPXPresent == 0} {return}

    :modify MPX :inactive F
}

proc click_mpx {args} {
  global MPXPresent MPXServer
  global Routing Relay
  global module

  if {$MPXPresent == 0} {return}

     if {![info exists Routing($module)]} {return}

     set mpx [first $Routing($module)]
     set input [second $Routing($module)]   
     set scope [second $args]

#    disconnect any existing use of the scope channel

    set register /$MPXServer/MPX?.$Relay($scope)
    set value 0
    catch {EG "register :pattern '$register' :value '$value'"}

    set register /$MPXServer/ISM.$Relay($scope)
    set value 0
    catch {EG "register :pattern '$register' :value '$value'"}

#    enable logic input $input for scope channel $scope

    if {$input <= 8} then {
        set register /$MPXServer/$mpx.lmux[expr $scope]
       set value [expr $input + 7]
    } else {
        set register /$MPXServer/$mpx.lmux[expr $scope + 4]
        set value [expr $input - 1]
    }
    catch {EG "register :name '$register' :value '$value'"}

#PMJ

    if {$input <= 8} then {
        set register /$MPXServer/$mpx.lmux[expr $scope+4]
       set value 0
    } else {
        set register /$MPXServer/$mpx.lmux[expr $scope]
        set value 0
    }
    catch {EG "register :name '$register' :value '$value'"}

#PMJ


#    connect scope channel $scope for logic use

    set register /$MPXServer/$mpx.$Relay($scope)
    set value 1
    catch {EG "register :name '$register' :value '$value'"}

}

