#
#    Control of SHARC link configuration for GREAT
#

set frame SHARC
set frametitle "SHARC Links"
set icontitle  "Sharc"

set MaxTries 20
set Do_Register_Delete 0

#    hardware available.  Assumes maximum of 12 PMC (Asp) cards each having 6 SHARC links
#    They are spread between up to 3 collator modules. There will be fewer than 12 cards
#    but the numbering is sparse.

set Sharc0 sharc0
set Sharc1 sharc1
set Sharc2 sharc2

set [set Sharc0]Present 0    ;#    discovered later from  experiment file
set [set Sharc1]Present 0    ;#    discovered later from  experiment file
set [set Sharc2]Present 0    ;#    discovered later from  experiment file

set syscon ""

#set aspnums {1 3 0 2 5 7 4 6}
set aspnums {1 3 0 2 5 7 4 6 9 11 8 10}
set linknums {5 4 3 2 1 0}

proc zero-inuse {} {
global AspInUse LinkInUse
for {set asp 0} {$asp <= 11} {incr asp} {
   set AspInUse($asp) 0
   for {set link 0} {$link <= 5} {incr link} {
      set LinkInUse($asp,$link) 0
   }
}
}
zero-inuse

set Configdir "$env(MIDASEXPBASE)"
catch {set Configdir "$env(EXPERIMENTBASE)"}

set Mergeregisterlist {}

lappend Mergeregisterlist [list Merge.Debug         merge   generic  "-nMerge_Debug -tint -fd"]
# Pileup netvar setup in sys.tcl
# lappend Mergeregisterlist [list Merge.PileupRate    merge   generic  "-nPileupRate -tint -fd"]

for {set asp 0} {$asp <= 11} {incr asp} {
    lappend Mergeregisterlist [list Merge.Asp$asp.Data         merge   generic  "-nasp[set asp]_Data -tint -fx"]
    lappend Mergeregisterlist [list Merge.Asp$asp.DataCounters merge   generic  "-nasp_DataCounters -tint -fx -a1 -i$asp"]
    lappend Mergeregisterlist [list Merge.Asp$asp.InUse        merge   generic  "-nMerge_AspsInUse -tint -a1 -i$asp"]
    lappend Mergeregisterlist [list Merge.Asp$asp.Produced     merge    xMEM     "-o0"]
    lappend Mergeregisterlist [list Merge.Asp$asp.Consumed     merge    xMEM     "-o4"]
    lappend Mergeregisterlist [list Merge.Asp$asp.DataBuffer   merge    bMEM     "-l64"]
}

    lappend Mergeregisterlist [list Merge.EventBuffer         merge   generic  "-nMerge_EventBuffer -tint -fx"]
    lappend Mergeregisterlist [list Merge.Output.DataBuffer   merge    bMEM     "-l64"]
    lappend Mergeregisterlist [list Merge.Output.CurrPointer  merge   generic  "-nMerge_EventCurrent -tint -fd"]
    lappend Mergeregisterlist [list Merge.OutputPause         merge   generic  "-nMerge_OutputPause -tint -fd"]

proc find_sharc_servers {} {
    global sharc0Present sharc1Present sharc2Present

    set sharc0Present 0
    set sharc1Present 0
    set sharc2Present 0

    set z [catch {eg "(experiment ?resources)"} m]
    if {$z!=0} then {puts stderr "$m"; return}

    set rs $m

   foreach r $rs {
      set name [second [first $r]]
      set type [second [fourth $r]]
      set flags [second [eigth $r]]
      if {$name == "sharc0" && $type == "register" && $flags == "0x3"} then {set sharc0Present 1}
      if {$name == "sharc1" && $type == "register" && $flags == "0x3"} then {set sharc1Present 1}
      if {$name == "sharc2" && $type == "register" && $flags == "0x3"} then {set sharc2Present 1}
   }
}

#    list of registers required by the GUI
#     this is in addition to a similar set created in the base SYS task for Merge

set Collateregisterlist {}

find_sharc_servers

for {set asp 0} {$asp <= 11} {incr asp} {

#   if {$AspInUse($asp) == 0} continue
 
   if {$asp <= 7} then {set server $Sharc1} else {set server $Sharc2}
   if {$asp <= 3} then {set server $Sharc0}

   if {[set [set server]Present] == 1} then {

      if {$syscon == ""} then {
          set syscon $server
          set SysResetregister [list VME.SYSRESET      $syscon    xMEM     "-a0xc2040000 -o0x404 -r1 -i0x00400000"]
      }

      for {set link 0} {$link <= 5} {incr link} {
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.InUse $server generic  "-nasp[set asp]_LinksInUse -tint -a1 -i$link"]
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.QDesc $server generic  "-nasp[set asp]_Queues_Desc -tint -fx -a1 -i[expr $link*5] -l5"]
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.QAddr $server generic  "-nasp[set asp]_Queues -tint -fx -a1 -i$link"]
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.QData      $server    bMEM     "-l64"]
      }
 
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Sig1       $server    sigTask  "-tasp[set asp] -sUSR1"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Sig2       $server    sigTask  "-tasp[set asp] -sUSR2"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Action     $server    generic  "-nasp[set asp]_EXEC_Action -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Parameter  $server    generic  "-nasp[set asp]_EXEC_Parameter -tstring"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.ID         $server    generic  "-nasp[set asp]_EXEC_ID -tstring"]
      lappend Collateregisterlist [list Collate.Asp$asp.LocalData            $server    generic  "-nasp[set asp]_Local_Data -tint -fx"]
      lappend Collateregisterlist [list Collate.Asp$asp.Data            $server    generic  "-nasp[set asp]_Data -tint -fx"]
      lappend Collateregisterlist [list Collate.Asp$asp.DataCounters    $server    generic  "-nasp_DataCounters -tint -fx -a1 -i$asp"]
      lappend Collateregisterlist [list Collate.Asp$asp.CAlive          $server    generic  "-nasp[set asp]_Alive -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Ctxenable       $server    generic  "-nasp[set asp]_TxEnable -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Chistenable     $server    generic  "-nasp[set asp]_HistEnable -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Chistmode       $server    generic  "-nasp[set asp]_HistMode -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Ctrace          $server    generic  "-nasp[set asp]_Trace -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Sstate          $server    generic  "-nasp[set asp]_State -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.TestMode        $server    generic  "-nasp[set asp]_TestMode -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.DelayTicks      $server    generic  "-nasp[set asp]_DelayTicks -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.PollTicks       $server    generic  "-nasp[set asp]_PollTicks -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Stats           $server    generic  "-nasp[set asp]_Stats -tint -ayes -i0"]
      lappend Collateregisterlist [list Collate.Asp$asp.Rates           $server    generic  "-nasp[set asp]_Rates -tint -ayes -i0"]

      lappend Collateregisterlist [list Collate.Asp$asp.PauseData	$server    generic  "-nasp[set asp]_PauseData -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Full		$server    generic  "-nasp[set asp]_FullCounters -tint -ayes -i0 -l3"]

      lappend Collateregisterlist [list Collate.Asp$asp.StopHere	$server    generic  "-nasp[set asp]_StopHere -tint"]

      lappend Collateregisterlist [list Collate.Asp$asp.DataBuffer      $server    bMEM     "-l64"]

      lappend Collateregisterlist [list Collate.Asp$asp.OutputAll       $server    generic  "-nasp[set asp]_OutputAll -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.OutputPause     $server    generic  "-nasp[set asp]_OutputPause -tint"]
   }
}

proc set-experiment dir {global Configdir; set Configdir $dir; restore_configuration}

proc define-register {class name attributes} {
   global EGallow Do_Register_Delete RegisterServer

   set EGallow_SAVE $EGallow
   set EGallow 0x20006         ;#   already exists

   set register /$RegisterServer/$name
   if {$Do_Register_Delete} {EG "register :pattern '$register' !delete"}
   set result [EG "register :name '$register' :class '$class' !new"]
   EG "register :name '$register' :object '$attributes'"

   set EGallow $EGallow_SAVE

   return $result
}

proc wait_for_completion {args} {
    global RegisterServer MaxTries

    set tries 1
    set TASK ""

    while {$tries < $MaxTries} {

        if {[llength $args] == 0} then {
            set-footer "Waiting for action to complete ($tries)"
        } else {
            if {[llength $args] > 1} then {
                set TASK "[first $args]."
                set-footer "[second $args] ($tries)"
            } else {
                set-footer "[first $args] ($tries)"
            }
        }

        set z [catch {EG "register :name '/$RegisterServer/[set TASK]EXEC.Action' ?value"} m ]

        if {$z != 0} then {
            midas-warning "Unable to confirm state of action\n$m"
            clear-footer
            return 1
        }

        if {$m == 0} then {
            clear-footer
            return 0
        }
        incr tries
        after 500
    }

    midas-warning "Action has not completed\nGiving up waiting"
    clear-footer
    return 1
}

proc make_registers {registerlist} {
    global EGreport RegisterServer

    set item [first $registerlist]
    set RegisterServer [second $item]
    set r [define-register [third $item] [first $item] "[fourth $item]"]
    if {$r == 0x20006} {return}          ;#  registers already exist

    set EGreport_SAVE $EGreport
    set EGreport -1
    set-footer "defining registers"

    foreach item $registerlist {
        set RegisterServer [second $item]
        define-register [third $item] [first $item] "[fourth $item]"
    }

    clear-footer
    set EGreport $EGreport_SAVE
}

proc restore_configuration {} {
   global Configdir
   global AspInUse LinkInUse

   set z [catch {open [file join $Configdir SHARC_current_configuration] r} file]
   if {$z != 0} then {set-footer "$file"; return}

   set configuration [split [read $file] \n]
   close $file

   set n 0
   for {set asp 0} {$asp <= 11} {incr asp} {
       set AspInUse($asp) [lindex $configuration $n]
       if {$AspInUse($asp)==""} {set AspInUse($asp) 0}
       incr n
       for {set link 0} {$link <= 5} {incr link} {
          set LinkInUse($asp,$link) [lindex $configuration $n]
          if {$LinkInUse($asp,$link)==""} {set LinkInUse($asp,$link) 0}
          incr n
       }
   }
   display-SHARC
}

proc load_configuration {} {
    global EGreport
    global Configdir
    global AspInUse LinkInUse
    global RegisterServer
    global sharc0Present sharc1Present sharc2Present
    global Sharc0 Sharc1 Sharc2
    global Mergeregisterlist Collateregisterlist

   make_registers $Mergeregisterlist
   make_registers $Collateregisterlist

   find_sharc_servers

    set EGreport_SAVE $EGreport
    set EGreport -1

   for {set asp 0} {$asp <= 11} {incr asp} {
       set RegisterServer merge
       write-register Merge.Asp$asp.InUse $AspInUse($asp)
       for {set link 0} {$link <= 5} {incr link} {
           if {$asp <= 7} then {set RegisterServer $Sharc1} else {set RegisterServer $Sharc2}
           if {$asp <= 3} then {set RegisterServer $Sharc0}
           if {[set [set RegisterServer]Present] == 1} then {write-register Collate.Asp$asp.Link$link.InUse $LinkInUse($asp,$link)}
       }
   }

   set z [catch {open [file join $Configdir SHARC_current_configuration] w} file]
   if {$z != 0} then {set-footer "$file"; return}
   for {set asp 0} {$asp <= 11} {incr asp} {
       puts $file $AspInUse($asp)
       for {set link 0} {$link <= 5} {incr link} {
           puts $file $LinkInUse($asp,$link)
       }
   }
   close $file

    set EGreport $EGreport_SAVE
}

proc click-asp {asp} {
    global AspInUse
    set AspInUse($asp) [expr ($AspInUse($asp) + 1) & 1]
    display-SHARC
}

proc click-link {asp link} {
    global AspInUse LinkInUse
    set LinkInUse($asp,$link) [expr ($LinkInUse($asp,$link) + 1) & 1]
    display-SHARC
}

proc action-sysreset {} {
    global syscon EGallow SysResetregister
    make_registers [list $SysResetregister]
    set egallow $EGallow
    set EGallow 0x1ffff
    EG "register :name '/$syscon/VME.SYSRESET' !initialise"
    set EGallow $egallow
}

proc do-sysreset {} {
    global started
    if {$started == 0} {make-frame; close-frame}
    set r [midas-confirmation "You are about to reboot the VME crate.\nAre you sure?"]
    if {$r == 1} then {after 100 action-sysreset}
}

proc display-SHARC {} {
   global AspInUse LinkInUse aspnums linknums

   for {set asp 0} {$asp <= 11} {incr asp} {

      set count [lsearch $aspnums $asp]

      if {$AspInUse($asp) == 0} then {
          [:path H$count].asp  configure -background red
      } else {
          [:path H$count].asp  configure -background green
      }

      for {set link 0} {$link <= 5} {incr link} {

          set i [lsearch $linknums $link]
          if {$LinkInUse($asp,$link) == 0} then {
              [:path H$count].link$i  configure -background red
          } else {
              [:path H$count].link$i  configure -background green
          }
      }
   }
}

proc do_setup {} {
    global sharc0Present sharc1Present sharc2Present AspInUse
    global Sharc0 Sharc1 Sharc2
    global RegisterServer

   find_sharc_servers

   for {set asp 0} {$asp <= 11} {incr asp} {
       
      if {$asp <= 7} then {set server $Sharc1} else {set server $Sharc2}
      if {$asp <= 3} then {set server $Sharc0}

      if {[set [set server]Present] == 1} then {

         set RegisterServer merge
         set data [read-register Merge.EventBuffer]
         write-attributes Merge.Output.DataBuffer "-a $data"
         set data [read-register Merge.Asp$asp.Data]
         write-attributes Merge.Asp$asp.DataBuffer "-a $data"
         set RegisterServer $server
         write-register Collate.Asp$asp.Data $data
         set data [read-register Collate.Asp$asp.LocalData]
         write-attributes Collate.Asp$asp.DataBuffer "-a $data"
         
         set RegisterServer $server
         for {set link 0} {$link <= 5} {incr link} {
            set data [read-register Collate.Asp$asp.Link$link.QAddr]
            write-attributes Collate.Asp$asp.Link$link.QData "-a $data"
         }

         set RegisterServer merge
         set data [read-register Merge.Asp0.DataCounters]
         set data [expr $data + 2 * 4 * $asp]
         write-attributes Merge.Asp$asp.Produced "-a $data"
         write-attributes Merge.Asp$asp.Consumed "-a $data"
         set RegisterServer $server
         write-register Collate.Asp$asp.DataCounters $data

         if {$AspInUse($asp) == 0} continue
         
         set RegisterServer $server
         write-register Collate.Asp$asp.EXEC.Action 3
         write-register Collate.Asp$asp.EXEC.Sig1 0
         wait_for_completion Collate.Asp$asp "waiting for $RegisterServer Asp$asp"
      }
   }
}

proc do_command {command} {
    global sharc0Present sharc1Present sharc2Present AspInUse
    global Sharc0 Sharc1 Sharc2
    global RegisterServer
    
    open-frame

   for {set asp 0} {$asp <= 11} {incr asp} {
   
      if {$AspInUse($asp) == 0} continue
    
      if {$asp <= 7} then {set server $Sharc1} else {set server $Sharc2}
      if {$asp <= 3} then {set server $Sharc0}

      if {[set [set server]Present] == 1} then {
         set RegisterServer $server
         write-register Collate.Asp$asp.EXEC.Action $command
         write-register Collate.Asp$asp.EXEC.Sig1 0
         wait_for_completion Collate.Asp$asp "waiting for $RegisterServer Asp$asp"
      }
   }
}

proc auto_start {} {start; close-frame}

proc start args {
   global started 
   if {$started == 0} then {make-frame; restore_configuration} else {open-frame}
   set started 1
   display-SHARC
}


proc make-frame {} {
   global env aspnums linknums

  :frame [self frame-name] :label "[self frame-title]" :show-footer T  :resize F

   :panel M :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 20
     :hskip 50
     :message M0 :label "SHARC links" :bold T

   :panel B :layout B :padx 10 :pady 10 :after FOOTER
     :layout H; :row-gap 10; :col-gap 20

    :button CONFIGURE :command load_configuration

   set count 0

  foreach panel {0 1 2} {

   :panel P$panel :layout H :padx 10 :pady 10 
     :layout H; 

    foreach canvas {0 1 2 3} {

        set w $count

        :canvas H$w  :w 50 :h 126
        [:path H$w] config -background $env(tkframebackground) 

        set asp [lindex $aspnums $count]
        entry [:path H$w].asp -relief flat -width 2 -justify center -foreground black
        [:path H$w].asp insert 0 $asp
        :draw window :tag H[set w]asp :value 16 64 -window [:path H$w].asp
        bind [:path H$w].asp <ButtonPress-1>  "click-asp $asp"

        set y 15
        for {set i 0} {$i <= 5} {incr i} {
           set link [lindex $linknums $i]
           entry [:path H$w].link$i -relief flat -width 1 -justify right -foreground black
           [:path H$w].link$i insert 0 $link
           :draw window :tag H[set w]link$i :value 39 $y -window [:path H$w].link$i 
           bind [:path H$w].link$i <ButtonPress-1>  "click-link $asp $link"

           incr y 20
        }
        if {$canvas == 1} {:next-row T}
        incr count
    }
  }

   :show T
}

