# Pattern_register.tcl---GREAT Pattern Register module control frame

set frame "Pattern_Register"
set frametitle "Pattern Register Control Module"
set icontitle "Pattern_Register"

if {[info exists env(VMEServer)]} then {set resource $env(VMEServer)} else {set resource vme}
set VMEserver $resource

set modulename pattern_register

set modulelist {???}
set moduleindex 0

set maxmodule 8

set modulelist {}
for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}

set module [lindex $modulelist $moduleindex]

set electronicsvisible 0
set electronicsframe "[self frame-name].electronics"

set UseMPX 0


set fifoTable [list "Almost Full" "Almost Empty" "Half Full" Empty Full]
set fifocount [llength $fifoTable]

set modcont [list "Ignore Track" "SHARC Enable" "FIFO reset" "STARX Enable" "Soft Reset Input" "Reset State Machines"]
set modcount [llength $modcont]

set inpcont [list "Reset Input FIFOs" "Enable Timestamp" "SYNC error reset" "SYNC to error" "" "Run Enable"]
set inpcount [llength $inpcont]

set grpalist [list "Single: input# AND Gate" "Single: input#" "Gated Group" \
  "Single: A# AND B# AND GateA" "Single: A# AND B#" "Gated Group: A# AND B#" \
  "Single: Stretched A# AND B# AND GateA" "Single: Stretched A# AND B#"]

set grpblist [list "Single: input# AND Gate" "Single: input#" "Gated Group"]

set Mode_l2r [list 0 1 2 4 5 6 12 13]
set Mode_r2l [list 0 1 2 -1 3 4 5 -1 -1 -1 -1 -1 6 7]

#    inspection line tables

set inspTable01 {
	Disconnected
	{GroupA_in
	A_0 A_1 A_2 A_3 A_4 A_5 A_6 A_7 A_8 A_9 A_10 A_11 A_12 A_13 A_14 A_15 }
	{GroupA_Stretched_in
	Str_A_0 Str_A_1 Str_A_2 Str_A_3 Str_A_4 Str_A_5 Str_A_6 Str_A_7 Str_A_8 Str_A_9 \
Str_A_10 Str_A_11 Str_A_12 Str_A_13 Str_A_14 Str_A_15 }
	{GroupB_in
	B_0 B_1 B_2 B_3 B_4 B_5 B_6 B_7 B_8 B_9 B_10 B_11 B_12 B_13 B_14 B_15 }

	{GroupA
	A_Hit A_End A_Gate A_FIFO_read A_FIFO_full A_FIFO_empty A_FIFO_write }
	{GroupB
	B_Hit B_End B_Gate B_FIFO_read B_FIFO_full B_FIFO_empty B_FIFO_write }
	SYNC Sync_detected Sync_error ANEB Reload_Window Load_Stamp Load_Enable
	Pause Resume STARX Out_Of_Step
	{Time_FIFO
	Time_Read Time_Write Time_Empty Time_Full }
	{Type_FIFO
	Type_Read Type_Empty Type_Full }
	{Internal_FIFO
	Int_Write_Clock Int_Write Int_renn Int_rclk Int_rcsn  
	Int_Almost_Full Int_Full Int_Empty Int_Almost_Empty Int_Partial_Reset Int_Master_reset }
	{VME
	ASn DS0n DS1n DTACK Iackn Iackinn Iackoutn Irq1 Irq2 Irq3 Irq4 Irq5 Irq6 Irq7 }
	Loadreg chip_select 
	{SHARC
        Sharc_clock Sharc_Ack Sharc_data0 Sharc_data1 Sharc_data2 Sharc_data3 }
	Fifo_read_request Fifo_ready VME_request Lost_track
}

set inspValue01 {
	0
	0x20 0x21 0x22 0x23 0x24 0x25 0x26 0x27 0x28 0x29 0x2a 0x2b 0x2c 0x2d 0x2e 0x2f
	0x70 0x71 0x72 0x73 0x74 0x75 0x76 0x77 0x78 0x79 0x7a 0x7b 0x7c 0x7d 0x7e 0x7f
	0x30 0x31 0x32 0x33 0x34 0x35 0x36 0x37 0x38 0x39 0x3a 0x3b 0x3c 0x3d 0x3e 0x3f
	0x62 0x63 0x42 0x4d 0x4e 0x4f 0x54
	0x40 0x41 0x43 0x50 0x51 0x52 0x55
	0x5b 0x44 0x45 0x46 0x47 0x48 0x49 0x56 0x57 0x5c 0x5d
	0x4a 0x53 0x4c 0x4b
	0x58 0x5a 0x59
	0x5e 0x5f 0xA9 0xA7 0xA8 
	0x60 0x61 0xA4 0xA1 0xAB 0xAC
	0x82 0x83 0x84 0x86 0x88 0x90 0x91 0x89 0x8a 0x8b 0x8c 0x8d 0x8e 0x8f 0x80 0x81
	0x92 0x93 0x94 0x95 0x96 0x97
	0xae 0xad 0xaf 0xb0
	
}

set inspTable23 {
	Disconnected
	{GroupA_in
	A_0 A_1 A_2 A_3 A_4 A_5 A_6 A_7 A_8 A_9 A_10 A_11 A_12 A_13 A_14 A_15 }
	{GroupA_Stretched_in
	Str_A_0 Str_A_1 Str_A_2 Str_A_3 Str_A_4 Str_A_5 Str_A_6 Str_A_7 Str_A_8 Str_A_9 \
Str_A_10 Str_A_11 Str_A_12 Str_A_13 Str_A_14 Str_A_15 }
	{GroupB_Delayed
	Del_B_0 Del_B_1 Del_B_2 Del_B_3 Del_B_4 Del_B_5 Del_B_6 Del_B_7 Del_B_8 Del_B_9 \
Del_B_10 Del_B_11 Del_B_12 Del_B_13 Del_B_14 Del_B_15 }
	{GroupB_in
	B_0 B_1 B_2 B_3 B_4 B_5 B_6 B_7 B_8 B_9 B_10 B_11 B_12 B_13 B_14 B_15 }

	{GroupA
	A_Hit A_End A_Gate A_FIFO_read A_FIFO_full A_FIFO_empty A_FIFO_write }
	{GroupB
	B_Hit B_End B_Gate B_FIFO_read B_FIFO_full B_FIFO_empty B_FIFO_write }
	SYNC Sync_detected Sync_error ANEB Reload_Window Load_Stamp Load_Enable
	Pause Resume STARX Out_Of_Step
	{Time_FIFO
	Time_Read Time_Write Time_Empty Time_Full }
	{Type_FIFO
	Type_Read Type_Empty Type_Full }
	{Internal_FIFO
	Int_Write_Clock Int_Write Int_renn Int_rclk Int_rcsn  
	Int_Almost_Full Int_Full Int_Empty Int_Almost_Empty Int_Partial_Reset Int_Master_reset }
	{VME
	ASn DS0n DS1n DTACK Iackn Iackinn Iackoutn Irq1 Irq2 Irq3 Irq4 Irq5 Irq6 Irq7 }
	Loadreg chip_select 
	{SHARC
        Sharc_clock Sharc_Ack Sharc_data0 Sharc_data1 Sharc_data2 Sharc_data3 }
	Fifo_read_request Fifo_ready VME_request Lost_track
}

set inspValue23 {
	0
	0x20 0x21 0x22 0x23 0x24 0x25 0x26 0x27 0x28 0x29 0x2a 0x2b 0x2c 0x2d 0x2e 0x2f
	0x70 0x71 0x72 0x73 0x74 0x75 0x76 0x77 0x78 0x79 0x7a 0x7b 0x7c 0x7d 0x7e 0x7f
	0x60 0x61 0x62 0x63 0x64 0x65 0x66 0x67 0x68 0x69 0x6a 0x6b 0x6c 0x6d 0x6e 0x6f
	0x30 0x31 0x32 0x33 0x34 0x35 0x36 0x37 0x38 0x39 0x3a 0x3b 0x3c 0x3d 0x3e 0x3f
	0x62 0x63 0x42 0x4d 0x4e 0x4f 0x54
	0x40 0x41 0x43 0x50 0x51 0x52 0x55
	0x5b 0x44 0x45 0x46 0x47 0x48 0x49 0x56 0x57 0x5c 0x5d
	0x4a 0x53 0x4c 0x4b
	0x58 0x5a 0x59
	0x5e 0x5f 0xA9 0xA7 0xA8 
	0x60 0x61 0xA4 0xA1 0xAB 0xAC
	0x82 0x83 0x84 0x86 0x88 0x90 0x91 0x89 0x8a 0x8b 0x8c 0x8d 0x8e 0x8f 0x80 0x81
	0x92 0x93 0x94 0x95 0x96 0x97
	0xae 0xad 0xaf 0xb0
	
}

set regTable {

 	ModCont 
 	ModStat		
	IntrCont		
	IntrSelct		
 	Tracks		
 	FifoFlags	
 	GrpAEnb		
 	GrpAInv		
 	GrpAMode		
 	GrpBEnb		
 	GrpBInv		
 	GrpBMode		
 	Insp0		
 	Insp1		
 	Insp2		
 	Insp3		
 	InpCont
 	GrpA	
 	GrpB	
 	Sync	
 	Pause	
 	Resume	
 	Undefined	
 	FifoWrt
	InpFifoFlags	
 	LoadTime
 }
set regcount [llength $regTable]

set ifTable [list A_Empty Full B_Empty Full Control_Empty Full Time_Empty Full]


loadsource common.vme


proc set-register {register v} {
    global modulename module
    write-vme-register $modulename#$module.$register $v
}

proc get-register {register} {
    global modulename module
    set v [read-vme-register $modulename#$module.$register]
    return $v
}

proc click-redisplay {} {
    global electronicsvisible
    global regTable regcount fifocount modcount inpcount

        redisplay-enable A
        redisplay-invert A

        redisplay-enable B
        redisplay-invert B

        redisplay-mode A
        redisplay-mode B

      	for {set i 0} { $i < 4 } { incr i} {
		:modify USE-DI$i  :label [read-vme-register PatternRegister.Insp[set i]Use]
	}

        :modify GRPASTR :value [expr [get-register GrpAStr]*20]
        :modify GRPABDEL :value [expr [get-register GrpABdel]*10]

        :modify GRPAINVB :value [expr [get-register GrpAInvB]]

        if {$electronicsvisible == 0} {return}

	for {set i 0} {$i<$regcount} { incr i}  {
		set vl [get-register [lindex $regTable $i] ]
		:modify REG$i :value $vl
	}

	set vl [get-register FifoFlags ]
      	for {set i 0} {$i<$fifocount} { incr i} {
		:modify FIFO$i :value [expr !(( $vl >> $i ) & 1)] 
	}
	
	set vl [get-register InpFifoFlags ]
      	for {set i 0} {$i<8} { incr i} {
		:modify IFIFO$i :value [expr (( $vl >> $i ) & 1)] 
	}
	 
	set vl [get-register ModCont ]
      	for {set i 0} {$i<$modcount} { incr i} {
		:modify MCONT$i :value [expr (( $vl >> $i ) & 1)] 
	}
	 
 	set vl [get-register InpCont ]
      	for {set i 0} {$i<$inpcount} { incr i} {
		:modify ICONT$i :value [expr (( $vl >> $i ) & 1)] 
	}
}

proc click-mode {r v} {
        global Mode_l2r
 	set-register Grp[set r]Mode [lindex $Mode_l2r $v]
        redisplay-mode $r
}

proc redisplay-mode {r} {
        global Mode_r2l
        set vl [get-register Grp[set r]Mode]
        :modify GRP[set r]MODE :value [lindex $Mode_r2l $vl]
}

proc click-stretch {vl} {
        set-register GrpAStr [expr ($vl+10)/20]
        :modify GRPASTR :value [expr [get-register GrpAStr]*20]
}

proc click-bdelay {vl} {
        set-register GrpABdel [expr ($vl+5)/10]
        :modify GRPABDEL :value [expr [get-register GrpABdel]*10]
}

proc click-ainvb {vl} {
        set-register GrpAInvB [expr $vl&1]
}

proc click-enable {r bit} {

        set vl [[:path GRP[set r]EN].bit$bit get]
        if {$vl == 0} then {set vl 1} else {set vl 0}

	set current [get-register Grp[set r]Enb ]
	set mask 0xfffe
	for { set i 0 } { $i<$bit} { incr i } {
		set mask [ expr ($mask << 1 ) + 1  ]
	}
	if { $vl == 0 } then { 
		set rg [ expr $current & $mask]
	} else {
		set rg [ expr $current | ( 1 << $bit)]
	}
	set-register Grp[set r]Enb $rg
	redisplay-enable $r
}

proc redisplay-enable {r} {

	set enable [get-register Grp[set r]Enb]
	for { set i 0 } { $i < 16 } { incr i } {
                [:path GRP[set r]EN].bit$i delete 0 end
                [:path GRP[set r]EN].bit$i insert 0 [expr ( $enable >> $i ) & 1 ]
	}
}

proc click-invert {r bit} {

        set vl [[:path GRP[set r]IN].bit$bit get]
        if {$vl == 0} then {set vl 1} else {set vl 0}

	set current [get-register Grp[set r]Inv ]
	set mask 0xfffe
	for { set i 0 } { $i<$bit } { incr i } {
		set mask [ expr ($mask << 1 ) + 1  ]
	}
	if { $vl == 0 } then { 
		set rg [ expr $current & $mask]
	} else {
		set rg [ expr $current | ( 1 << $bit )]
	}
	set-register Grp[set r]Inv $rg
	redisplay-invert $r
}

proc redisplay-invert {r} {

	set invert [get-register Grp[set r]Inv]
	for { set i 0 } { $i < 16 } { incr i } {
                [:path GRP[set r]IN].bit$i delete 0 end
                [:path GRP[set r]IN].bit$i insert 0 [expr ( $invert >> $i ) & 1 ]
	}
}

proc click-pattern { reg vl } {
	global regTable
# need to be able to write the value out to the register named here
	set regnum [lindex [split $reg G] 1]
	set regnam [lindex $regTable $regnum]
	set-register $regnam $vl
#	set-footer "Click : $regnam with : $vl "
	click-redisplay
}

proc click-inspection01 { reg nam vl } {
	global UseMPX inspTable01 inspValue01 modulename module
# need to be able to write the value out to the register named here
#    disconnect any existing use of this line
	set line [lindex [split $reg I] 1]
#
        write-vme-registers $modulename#?.Insp$line 0
	write-vme-register PatternRegister.Insp[set line]Use "disconnected"
#
	set-register Insp$line [ lindex $inspValue01 $vl ]
#	set-footer "Click-insp Line : $line with : $vl "
	write-vme-register PatternRegister.Insp[set line]Use "Connected to module $module; signal $nam"
	if {$UseMPX} then {connect-MPX $line}
        click-redisplay
}

proc click-inspection23 { reg nam vl } {
	global UseMPX inspTable23 inspValue23 modulename module
# need to be able to write the value out to the register named here
#    disconnect any existing use of this line
	set line [lindex [split $reg I] 1]
#
        write-vme-registers $modulename#?.Insp$line 0
	write-vme-register PatternRegister.Insp[set line]Use "disconnected"
#
	set-register Insp$line [ lindex $inspValue23 $vl ]
#	set-footer "Click-insp Line : $line with : $vl "
	write-vme-register PatternRegister.Insp[set line]Use "Connected to module $module; signal $nam"
	if {$UseMPX} then {connect-MPX $line}
        click-redisplay
}
proc connect-MPX {l} {}

proc click-module {reg vl } {
	set bithit [lindex [split $reg T] 1 ]
	set current [get-register ModCont ]
	set mask 0xfffe
	for { set i 0 } { $i<$bithit } { incr i } {
		set mask [ expr ($mask << 1 ) + 1  ]
	}
	if { $vl == 0 } then { 
		set rg [ expr $current & $mask]
	} else {
		set rg [ expr $current | ( 1 << $bithit )]
	}
	set-register ModCont $rg
	click-redisplay
}

proc click-input {reg vl } {
	set bithit [lindex [split $reg T] 1 ]
	set current [get-register InpCont ]
	set mask 0xfffe
	for { set i 0 } { $i<$bithit } { incr i } {
		set mask [ expr ($mask << 1 ) + 1  ]
	}
	if { $vl == 0 } then { 
		set rg [ expr $current & $mask]
	} else {
		set rg [ expr $current | ( 1 << $bithit )]
	}
	set-register InpCont $rg
	click-redisplay
}

proc click-readfifo {} {
	:modify FIFORD :value [get-register FifoRd ]
	click-redisplay
}

proc click-channel { vl } {
	global module modulelist
	set module [ lindex $modulelist $vl]
        :modify MODULE :value $vl
	click-redisplay
}

proc setup-idents {} {
	global modulelist modulename 
    
	foreach i $modulelist {
		write-vme-register $modulename#$i.GrpA 	[expr 0xc2000000 + ( $i << 17 ) ]
		write-vme-register $modulename#$i.GrpB 	[expr 0xc2010000 + ( $i << 17 ) ]
		write-vme-register $modulename#$i.Sync 	[expr 0x90400000 + ( $i << 24 ) ]
		write-vme-register $modulename#$i.Pause  	[expr 0x90200000 + ( $i << 24 ) ]	
		write-vme-register $modulename#$i.Resume  	[expr 0x90300000 + ( $i << 24 ) ]	
		write-vme-register $modulename#$i.Undefined 	[expr 0x90000000 + ( $i << 24 ) ]
	}
	click-redisplay
}

proc click-software {} {
   global modulename
   inform [set modulename]sftwre start
}

proc click-electronics {} {
#  display electronics sub frame
   global electronicsvisible electronicsframe
   if {$electronicsvisible==0} then {make-electronics} else {open-frame $electronicsframe}
   click-redisplay
}

proc start args {
   global started CurrentVMEServer modulename module moduleindex modulelist

   if {$started == 0} then {
       make-frame
       EGbindings
   }
   set started 1
   open-frame

   clear-footer
   clear-busy
   set EGreport 0

   set maxmodule [inform vmecontrol inquire [set modulename]count]

   set modulelist {}
   for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}

   set moduleindex 0
   set module [lindex $modulelist $moduleindex]

   :modify MODULE :strings $modulelist :value 0

   set CurrentVMEServer [VMEmodule2server $modulename#$module]
   click-redisplay
}

proc click-quit {} {close-frame}

proc finish args {destroy-frame}

proc click arg {
    global UseMPX
  
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
       
      MODULE    {click-channel $v}
      GRPAMODE	{click-mode A $v}
      GRPBMODE	{click-mode B $v}
      USEMPX    {set UseMPX $v}
      GRPASTR   {click-stretch $v}
      GRPABDEL  {click-bdelay $v}
      
      GRPAINVB  {click-ainvb $v}

      ENGINEERING       {click-$v}
      REDISPLAY         {click-redisplay}

      default           {
           set p "click_[lowercase $w]"
           if {[info procs $p] == "$p"} then {$p [list $v $i]} else {insert-debug "$arg"}
      }
   }
}

proc make-frame {} {
  global env inspTable01 inspTable23 modulelist UseMPX
  global grpalist grpblist

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/vme_module" \
      :icon-name "[self icon-title]" 

  :panel P1  :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 10
     :choice-stack MODULE :label "Current Module:" :strings $modulelist :valuex 16c

   :panel INPUTS :layout T :padx 10 :pady 10
	:layout H; :row-gap 10 ; :col-gap 10

	:message GRPA :label "Input Group A "
	:choice-stack GRPAMODE :label "Mode" :strings $grpalist
        :next-row T
        :slider GRPASTR :label "Stretch (ns)" :valuex 80 :value 0 :min 0 :max 300 :resolution 20
        :next-row T
        :slider GRPABDEL :label "Delay B (ns)" :value 0 :min 0 :max 300 :resolution 10
        :checkbox GRPAINVB :label "Invert B"

	:next-row T; :col-gap 0
	:message GRPAENB :label "Enable" :w 8
        :message GRPAENB15 :label "msb"

        :canvas GRPAEN  :w 370 :h 28
        [:path GRPAEN] config -background $env(tkframebackground)

        set x 360
        set y 15
        for {set i 0} {$i < 16} {incr i} {
           if {$i == 4} {incr x -15}
           if {$i == 8} {incr x -15}
           if {$i == 12} {incr x -15}
           entry [:path GRPAEN].bit$i -relief flat -width 1 -justify right
           [:path GRPAEN].bit$i insert 0 " "
           :draw window :tag GRPAENbit$i :value $x $y -window [:path GRPAEN].bit$i 
           bind [:path GRPAEN].bit$i <ButtonPress-1>  "click-enable A $i"
           incr x -20
        }

        :message GRPAENB0 :label "lsb"

	:next-row T
	:message GRPAINV :label "Invert" :w 8
        :message GRPAINV15 :label "msb"

        :canvas GRPAIN  :w 370 :h 28
        [:path GRPAIN] config -background $env(tkframebackground)

        set x 360
        set y 15
        for {set i 0} {$i < 16} {incr i} {
           if {$i == 4} {incr x -15}
           if {$i == 8} {incr x -15}
           if {$i == 12} {incr x -15}
           entry [:path GRPAIN].bit$i -relief flat -width 1 -justify right
           [:path GRPAIN].bit$i insert 0 " "
           :draw window :tag GRPAINbit$i :value $x $y -window [:path GRPAIN].bit$i 
           bind [:path GRPAIN].bit$i <ButtonPress-1>  "click-invert A $i"
           incr x -20
        }

        :message GRPAINV0 :label "lsb"

        :next-row T; :vskip 10
        :col-gap 10
	:message GRPB :label "Input Group B "
	:choice-stack GRPBMODE :label "Mode" :strings $grpblist

	:next-row T; :col-gap 0
	:message GRPBENB   :label "Enable" :w 8
        :message GRPBENB15 :label "msb"

        :canvas GRPBEN  :w 370 :h 28
        [:path GRPBEN] config -background $env(tkframebackground)

        set x 360
        set y 15
        for {set i 0} {$i < 16} {incr i} {
           if {$i == 4} {incr x -15}
           if {$i == 8} {incr x -15}
           if {$i == 12} {incr x -15}
           entry [:path GRPBEN].bit$i -relief flat -width 1 -justify right
           [:path GRPBEN].bit$i insert 0 " "
           :draw window :tag GRPBENbit$i :value $x $y -window [:path GRPBEN].bit$i 
           bind [:path GRPBEN].bit$i <ButtonPress-1>  "click-enable B $i"
           incr x -20
        }

        :message GRPBENB0 :label "lsb"

	:next-row T
	:message GRPBINV :label "Invert" :w 8
        :message GRPBINVB15 :label "msb"

        :canvas GRPBIN  :w 370 :h 28
        [:path GRPBIN] config -background $env(tkframebackground)

        set x 360
        set y 15
        for {set i 0} {$i < 16} {incr i} {
           if {$i == 4} {incr x -15}
           if {$i == 8} {incr x -15}
           if {$i == 12} {incr x -15}
           entry [:path GRPBIN].bit$i -relief flat -width 1 -justify right
           [:path GRPBIN].bit$i insert 0 " "
           :draw window :tag GRPBINbit$i :value $x $y -window [:path GRPBIN].bit$i 
           bind [:path GRPBIN].bit$i <ButtonPress-1>  "click-invert B $i"
           incr x -20
        }

        :message GRPBINVB0 :label "lsb"

  :panel INSP :layout T :padx 5 :pady 5
       :layout H; :col-gap 5; :row-gap 10
      :menubutton MUX-DI0 :label "Digital Inspection 0:"  :w 20 :menu $inspTable01 :command click-inspection01
      :message USE-DI0   :label ""
      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 20 :menu $inspTable01 :command click-inspection01
      :message USE-DI1   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 20 :menu $inspTable23 :command click-inspection23
      :message USE-DI2   :label ""
      :next-row T
      :menubutton MUX-DI3 :label "Digital Inspection 3:"  :w 20 :menu $inspTable23 :command click-inspection23
      :message USE-DI3   :label ""

   :panel CLICK :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 30; :row-gap 10
      :vskip 10
      :button REDISPLAY 
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :checkbox USEMPX :label "Connect to Scope Channels"  :value $UseMPX

  :show T
}

proc make-electronics {} {
  global electronicsframe electronicsvisible
  global regTable regcount fifoTable fifocount ifTable modcont modcount inpcont inpcount

  :frame "$electronicsframe" :label "[self frame-title] Electronics" :resize F :transient T

  :panel REGS  :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 10
     :col-gap 0
     set rowcount 0
     for {set i 0} {$i<$regcount} { incr i} {
        :text REG$i :label [lindex $regTable $i] :valuex 10c :w 10  :command click-pattern
	set rowcount [expr $rowcount + 1]
 	if { $rowcount == 4 } then {
		:next-row T
		set rowcount 0  
	}
     }

   :panel FIFOREAD :layout T :padx 5 :pady 5
	:layout H
	:button FIFORDB :label "Read Main FIFO" :w 14 :command click-readfifo
	:text FIFORD :valuex 10c :w 10 :deaf T
	:button SETUPID :label "Setup Idents for all " :command setup-idents
   :panel  FIFOFLAG :layout L :padx 5 :pady 5 :row-gap 5; :col-gap 5

     :col-gap 0
	:message M1 :label "Internal 256k FIFO :"
	:next-row T
     	for {set i 0} {$i<$fifocount} { incr i} {
		:checkbox FIFO$i :label [lindex $fifoTable $i]  :deaf T :valuex 10c
		:next-row T
	}

  :panel  INPUTFIFO :layout L :padx 5 :pady 5 :row-gap 5; :col-gap 5

     :col-gap 0
	:message M2 :label "Input FIFOs:"
	:next-row T
     	for {set i 0} {$i<8} { incr i} {
		:checkbox IFIFO$i :label [lindex $ifTable $i]  :deaf T :valuex 13c
		:next-row T
	}
  :panel  CONTROLM :layout L :padx 5 :pady 5 :row-gap 5; :col-gap 5

     :col-gap 0
	:message M3 :label "Module Controls :"
	:next-row T
     	for {set i 0} {$i<$modcount} { incr i} {
		:checkbox MCONT$i :label [lindex $modcont $i]  :command click-module :valuex 18c
		:next-row T
	}
	
  :panel  CONTROLI  :layout L :padx 5 :pady 5 :row-gap 5; :col-gap 5

     :col-gap 0
	:message M4 :label "Input Controls :"
	:next-row T
     	for {set i 0} {$i<$inpcount} { incr i} {
		:checkbox ICONT$i :label [lindex $inpcont $i]  :command click-input :valuex 15c
		:next-row T
	}
 	:next-row T

   :panel ECLICK :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 30; :row-gap 10
      :vskip 10
      :button EREDISPLAY  :label Redisplay :command click-redisplay

  :show T
 set electronicsvisible 1
 
}
