# 
# March 2001 -  GREAT TDR32V DA
#    updated for metronome2 and pattern register  feb 2004


set VERSION "GREAT"

set env(RDOUThdwre) Merge

loadsource sys.common

set frametitle "MIDAS GREAT Experiment Control (TDR32V)"

set CAMACPresent 1
set VMEPresent 1
set VXIPresent 1

set CAMACEnable 1
set VMEEnable 1
set VXIEnable 1

set X2VBPresent 0

set RDOUTEnable 1

set TSPresent 1
set EBPresent 1

set TSEnable 0

set histPresent 1
set histEnable 1

set NamesPres 0
set Names {}

set txEnable 0
set ebtxEnable 0

if {[info exists env(RDOUThdwre)] == 0} then {set hdwre Merge} else {set hdwre $env(RDOUThdwre)}
set RDOUThdwre $hdwre

set POLLTICKS 100000


set DelayTicks 6

#    append to common lists

lappend registerlist [list NetVar.DACQ.Chistmode	generic  "-nDACQ_HistMode -tint"]
lappend registerlist [list NetVar.DACQ.CPileupRate	generic  "-nDACQ_PileupRate -tint"]
lappend registerlist [list NetVar.DACQ.InitialTimeStamp	generic  "-nMerge_InitialTimeStamp -tuint"]
lappend registerlist [list NetVar.DACQ.Spaused          generic  "-nMerge_IsPaused -tint"]

set SetupMessage "\n\
Are you sure you wish to SETUP the data acquisition system?\n\n\
SETUP will STOP data acquisition.\n\
Configure the VXI Control software and restore VXI parameter settings.\n\
It will also recreate all histograms selected.\n\
This may take several minutes.\n\n\
If you decide to continue please wait for the SETUP sequence to complete and DO NOT touch the system while it is in progress.
"

proc Set_Options {} {
    global Options

    load_Options

    Set_Common_Options

    update_Options
}


proc delete_spectra {} {
   global SpectrumServer
}

proc create_spectra {} {
    global SpectrumServer Options

   set range $Options(Stat.channels)
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Stat' !new)" } m]
   map_spectrum "Stat 0"

   set range $Options(Rate.channels)
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Rate' !new)" } m]
   
#     all other spectra created by the software histogram interface
    map_spectra
}

proc map_spectra {} {
   global EGreport env
   global RDOUTEnable

   if {$RDOUTEnable == 0} then {return}
   
   inform shist start
   inform shist close-frame

   set EGreport_SAVE $EGreport
   set EGreport -1

   set l [spectra-names]
   set n 0
   foreach item $l {
       set name [second $item]
       set Xname [inform shist Give_XlateR $name]
       set module [first [split $Xname .]]
       set adc    [second [split $Xname .]]
       set m [second [split $module #]]
       set a [string range $adc 3 end]
       if {"[first [split $module #]]" == "tdr32v"} then {
          set v [map_spectrum "$name [expr ($m << 5) + $a]"]
          if {"$v" != "0"} then {incr n}
       }
   }

   if {$n == 0} then {write-register NetVar.DACQ.Cspectramapped 1}

   set EGreport $EGreport_SAVE

   set-footer "mapped [llength $l] spectra"
}

proc click-rdout  {v} {
    global POLLTICKS

   global RDOUThdwre RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set z [catch {
        if {$v==0} then {
#    Halt

              inform SHARC do_command 1
              inform SHARC close-frame
              
              after cancel Check-DA
              execute-command 1 "Halt"
        }
        if {$v==1} then {
#    Go
              if {[read-register NetVar.DACQ.Cspectramapped] != 1} then {map_spectra}

              execute-command 2 "Go"
              after 5000 Check-DA
              
              inform SHARC do_command 2
              inform SHARC close-frame
        }
        if {$v==2} then {
#    Setup

              Poll_Ticks $POLLTICKS
              
              after cancel Check-DA
              execute-command 3 "Setup"

# We must do SHARC (Collator) Setup after Merge, since Merge sets up
# addresses to be used by the Collators
# but there's still a problem - timing - so we wait a bit
#
              after 2000
              inform SHARC do_setup
              inform SHARC close-frame
        }
        if {$v==3} then {
#    Reset

              inform SHARC do_command 9
              inform SHARC close-frame
              
              after cancel Check-DA
              execute-command 9 "Reset"
        }
        wait_for_completion
    } m ]
    redisplay-rdout
    clear-footer
}

proc redisplay-rdout {} {
   global RDOUTEnable

   if {$RDOUTEnable == 0} then {
      :modify RDOUT :value -1
      :modify PAUSE :value 0
      return
   }
   set state [read-register NetVar.DACQ.Sstate]
   :modify RDOUT :value [expr $state -1]

   set pause [read-register NetVar.DACQ.Spaused]
   :modify PAUSE :value $pause
}

proc redisplay-camac {} {:modify CAMAC :value -1}

proc Custom_PostCheck {arg} {

    inform SHARC start
    inform SHARC load_configuration
    inform SHARC close-frame

    if {$arg == 2} {                            ;#  setup
       inform metronome2 start
       inform metronome2 close-frame

       inform pattern_register start
       inform pattern_register close-frame

       inform tdr32v start
       inform tdr32v close-frame
    }
}

proc Custom_SetupD {option} {    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
    upvar opt opt

     inform metronome2 click-calibrate
     set opt 1    ;# will force VXI parameter restore
}

# command 16 is User Application 1  (Merge_start() in Merge DA code)
# tells the merge DA program to allow data through, starting with timestamp
# equal or greater than the metronome re-synch time
# Should be called after Go_Electronics which has invoked the metronome's
# synchronize-all to set up the initial timestamp value for the cards and
# written it to the merge program
proc Custom_PostGo {} {

   insert-log "START to Merge"
   click-special 16
}

proc Go_Electronics {} {

    insert-log "GO to Metronome2: STARX: 0"
    inform metronome2 set-register Start 1    ;#   removes system reset (starx)
    click-vme 4 ;# This calls a Custom_PostGo for the pattern registers
    inform metronome2 synchronize-all
}

proc Stop_Electronics {} {

    insert-log "STOP to Metronome2: STARX: 1"
    inform metronome2 set-register Start 0    ;#   asserts system reset (starx)
}

# command 17 is User Application 2  (Merge_pause() in Merge DA code)
# This is a toggle.
# if DA is outputting data this tells it to discard data (PAUSE state)
# if DA is discarding data this tells it to restart from the next good
# SYNC pulse timestamp. Otherwise do nothing.
proc click-pause {v} {
   set pause [read-register NetVar.DACQ.Spaused]
   if {$pause != $v} then {click-special 17}
   redisplay-rdout
   return  [read-register NetVar.DACQ.Spaused]
}

