#  metronome.defn.tcl

proc {Add_Metronome_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]

   set CurrentVMEServer  $server
 
   for {set i 0} {$i < 8} {incr i} {
      define-vme-register $name xVME control   "-a$A16addrbase -w16 -o0 -prw -d16 -zx"
      define-vme-register $name xVME status    "-a$A16addrbase -w16 -o2 -pro -d16 -l4 -zx"
      define-vme-register $name xVME status.stary    "-a$A16addrbase -w16 -o2 -pro -d16 -l1 -b0 -zd"
      define-vme-register $name xVME status.starx    "-a$A16addrbase -w16 -o2 -pro -d16 -l1 -b1 -zd"
   }
}


proc {Metronome_DAQ-reset} {args} {
#   
    global CurrentVMEServer EGallow EGreport
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
    insert-log "RESET to Metronome"
# set STARX to reset the whole system 
    write-vme-register $module.control 2
# then clear it again. No clock running so not started yet.
#   write-vme-register $module.control 0

}

proc {Metronome_DAQ-go} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    insert-log "GO to Metronome"
    write-vme-register $module.control 1
}

proc {Metronome_DAQ-halt} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    insert-log "HALT to Metronome"
    write-vme-register $module.control 0

}

proc {Metronome_DAQ-setup} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.control 0
}

#   for parameter save/restore
set {Metronome_registersavepatterns} {}


