#  metronome2.defn.tcl

proc {Add_Metronome2_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server
 
   for {set i 0} {$i < 8} {incr i} {
      define-vme-register $name xVME load.Ch$i     "-a$A16addrbase -w16 -o[expr (2 * $i) + 1] -pwo -d8"
   }
   define-vme-register $name xVME ArmCalTest      "-a$A16addrbase -w16 -o0x11 -pwo -d8"
   define-vme-register $name xVME ChanSel         "-a$A16addrbase -w16 -o0x19 -pwo -d8"
   define-vme-register $name xVME Delay           "-a$A16addrbase -w16 -o0x0f -pro -d8 -zx"
   define-vme-register $name xVME Initialise      "-a$A16addrbase -w16 -o0x13 -pwo -d8"
   define-vme-register $name xVME Start           "-a$A16addrbase -w16 -o0x15 -pwo -d8"
   define-vme-register $name xVME Status          "-a$A16addrbase -w16 -o0x01 -pro -d8 -zx -l3 -b0"
   define-vme-register $name xVME PLLState        "-a$A16addrbase -w16 -o0x01 -pro -d8 -l1 -b1"
   define-vme-register $name xVME ChError         "-a$A16addrbase -w16 -o0x01 -pro -d8 -l1 -b2"

   define-vme-register $name xVME IVec            "-a$A16addrbase -w16 -o0x1d -pwo -d8"
   define-vme-register $name xVME IEnable         "-a$A16addrbase -w16 -o0x1f -pwo -d8"
   define-vme-register $name xVME IStatus         "-a$A16addrbase -w16 -o0x15 -pro -d8 -zx"
   define-vme-register $name xVME Clear           "-a$A16addrbase -w16 -o0x1b -pwo -d8"

   define-vme-register $name xVME Counter         "-a$A32addrbase -w32 -o0xfffc -prw -d32 -zx"
}


proc {Metronome2_DAQ-reset} {args} {
#   
    global CurrentVMEServer EGallow EGreport
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.Status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Metronome2_DAQ-go} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Metronome2_DAQ-halt} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Metronome2_DAQ-setup} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {Metronome2_registersavepatterns} {}


