#  pattern_generator.defn.tcl

proc {Add_Pattern_Generator_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]

   set CurrentVMEServer  $server
 
   for {set i 0} {$i < 8} {incr i} {
# registers to control the pulse height
      define-vme-register $name xVME pulse_height0   "-a$A16addrbase -w16 -o0 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height1   "-a$A16addrbase -w16 -o2 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height2   "-a$A16addrbase -w16 -o4 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height3   "-a$A16addrbase -w16 -o6 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height4   "-a$A16addrbase -w16 -o8 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height5   "-a$A16addrbase -w16 -o10 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height6   "-a$A16addrbase -w16 -o12 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height7   "-a$A16addrbase -w16 -o14 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height8   "-a$A16addrbase -w16 -o16 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height9   "-a$A16addrbase -w16 -o18 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height10   "-a$A16addrbase -w16 -o20 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height11   "-a$A16addrbase -w16 -o22 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height12   "-a$A16addrbase -w16 -o24 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height13   "-a$A16addrbase -w16 -o26 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height14   "-a$A16addrbase -w16 -o28 -prw -d16 -l4 -b0 -zd"
      define-vme-register $name xVME pulse_height15   "-a$A16addrbase -w16 -o30 -prw -d16 -l4 -b0 -zd"
 # registers for the random number generator seed 
     define-vme-register $name xVME pulse_seed0       "-a$A16addrbase -w16 -o32 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed1       "-a$A16addrbase -w16 -o34 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed2       "-a$A16addrbase -w16 -o36 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed3       "-a$A16addrbase -w16 -o38 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed4       "-a$A16addrbase -w16 -o40 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed5       "-a$A16addrbase -w16 -o42 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed6       "-a$A16addrbase -w16 -o44 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed7       "-a$A16addrbase -w16 -o46 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed8       "-a$A16addrbase -w16 -o48 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed9       "-a$A16addrbase -w16 -o50 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed10       "-a$A16addrbase -w16 -o52 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed11       "-a$A16addrbase -w16 -o54 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed12       "-a$A16addrbase -w16 -o56 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed13       "-a$A16addrbase -w16 -o58 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed14       "-a$A16addrbase -w16 -o60 -pwo -d16 -zd"
     define-vme-register $name xVME pulse_seed15       "-a$A16addrbase -w16 -o62 -pwo -d16 -zd"
# registers to control the activity of the generator

      define-vme-register $name xVME pulse   		"-a$A16addrbase -w16 -o64 -prw -d16 -zx"
      define-vme-register $name xVME polarity  		"-a$A16addrbase -w16 -o66 -prw -d16  -zx"
      define-vme-register $name xVME control  		"-a$A16addrbase -w16 -o68 -prw -d16  -zx"
      define-vme-register $name xVME status    		"-a$A16addrbase -w16 -o70 -pro -d16 -l4 -zx"

      define-vme-register $name xVME control.select    	"-a$A16addrbase -w16 -o68 -prw -d16 -l1 -b0 -zd"
      define-vme-register $name xVME control.start    	"-a$A16addrbase -w16 -o68 -prw -d16 -l1 -b1 -zd"
      define-vme-register $name xVME control.step    	"-a$A16addrbase -w16 -o68 -prw -d16 -l1 -b2 -zd"
      define-vme-register $name xVME control.reset    	"-a$A16addrbase -w16 -o68 -prw -d16 -l1 -b3 -zd"
   }
}


proc {Pattern_Generator_DAQ-reset} {args} {
#   
    global CurrentVMEServer EGallow EGreport
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
# set STARX to reset the whole system 
    write-vme-register $module.control.reset 1
# then clear it again. 
   write-vme-register $module.control.reset 0

}

proc {Pattern_Generator_DAQ-go} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.control.start 1
}

proc {Pattern_Generator_DAQ-halt} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.control.start 0
    write-vme-register $module.control.select 0

}

proc {Pattern_Generator_DAQ-setup} {args} {
#   
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.control.select 1
# set up the random seeds 
    write-vme-register $module.pulse_seed0 1
    write-vme-register $module.pulse_seed1 0x2001
    write-vme-register $module.pulse_seed2 0x2003
    write-vme-register $module.pulse_seed3 0x1001
    write-vme-register $module.pulse_seed4 0x1002
    write-vme-register $module.pulse_seed5 0x1004
    write-vme-register $module.pulse_seed6 0x1008
    write-vme-register $module.pulse_seed7 0x1010
    write-vme-register $module.pulse_seed8 0x1020
    write-vme-register $module.pulse_seed9 0x1040
    write-vme-register $module.pulse_seed10 0x1080
    write-vme-register $module.pulse_seed11 0x1101

# set up the delays for the focal plane pulses
    write-vme-register $module.pulse_seed12 40
    write-vme-register $module.pulse_seed13 41
    write-vme-register $module.pulse_seed14 42
    write-vme-register $module.pulse_seed15 43

# and the pulse heights for the focal plane 
    write-vme-register $module.pulse_height12 4
    write-vme-register $module.pulse_height13 6
    write-vme-register $module.pulse_height14 7
    write-vme-register $module.pulse_height15 8

}

#   for parameter save/restore
set {Pattern_Generator_registersavepatterns} {}


