
set MPXPresent 1
if {[info exists env(MPXServer)]} then {set MPXServer $env(MPXServer)} \
    else {set MPXServer vme}

#    Routing table
#       index   pattern register inspection line #
#       item 1     MPX module 
#       item 2     logic input
#       item 3     scope channel
set Routing(0)  [list MPX1 1 1]
set Routing(1)  [list MPX1 2 2]
set Routing(2)  [list MPX1 3 3]
set Routing(3)  [list MPX1 4 4]

#    register to connect multiplex signal for scope channel i
set Relay(1) rlyA0
set Relay(2) rlyA1
set Relay(3) rlyB0
set Relay(4) rlyB1


proc connect-MPX {line} {
  global MPXPresent MPXServer
  global Routing Relay
  global module

  if {$MPXPresent == 0} {return}

     set mpx [first $Routing($line)]
     set input [second $Routing($line)]   
     set scope [third $Routing($line)]

#    disconnect any existing use of the scope channel

    set register /$MPXServer/MPX?.$Relay($scope)
    set value 0
    catch {EG "register :pattern '$register' :value '$value'"}

    set register /$MPXServer/ISM.$Relay($scope)
    set value 0
    catch {EG "register :pattern '$register' :value '$value'"}

#    enable logic input $input for scope channel $scope

    if {$input <= 8} then {
        set register /$MPXServer/$mpx.lmux[expr $scope]
        set value [expr $input + 7]
    } else {
        set register /$MPXServer/$mpx.lmux[expr $scope + 4]
        set value [expr $input - 1]
    }
    catch {EG "register :name '$register' :value '$value'"}

#    connect scope channel $scope for logic use

    set register /$MPXServer/$mpx.$Relay($scope)
    set value 1
    catch {EG "register :name '$register' :value '$value'"}

}

