# This patch adds custom_PostGo (used by the pattern registers)
# otherwise routine should be as in sys.common.tcl
# vmecontrol is also patched
# routine is in pattern_register.defn.tcl
#

proc click-vme {action args} {
    global VMEPresent VMEEnable

  if {$VMEPresent == 0} then {return}
  if {$VMEEnable == 0} then {:modify VME :value -1; return}

   starttask vmecontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-reset}
      3    {set p DAQ-setup}
      4    {set p DAQ-custom_PostGo}
    }

   set-footer "sending $p to VME control task"
   set-busy
   if {[llength $args] == 0} then {
       set z [catch {send vmecontrol $p} m]
   } else {
       set z [catch {send vmecontrol $p [first $args]} m]
   }
   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-vme
   update_button_states
}

# Temporary - I hope - the version in common is buggy - I think, must check
proc execute-command {args} {
    global RDOUTserver RDOUThdwre RDOUTserverList

#    first      action
#    second     message
#    third      parameter
#    fourth     signal number
#    fifth      task name

    if {[llength $args] > 4} then {set TASK [fifth $args]} else {set TASK EXEC}

    foreach server $RDOUTserverList {
        set pid [EG "register :name '/$server/NetVar.$TASK.PID' ?value"]
        if {[llength $args] > 2} {EG "register :name '/$server/NetVar.$TASK.Parameter' :value '[third $args]'"}
        EG "register :name '/$server/NetVar.$TASK.Action' :value '[first $args]'"
        if {[llength $args] > 3} {
            set usrsig [fourth $args]
        } else {
            set usrsig 1
        }
        EG "register :name '/$server/SigTask.$TASK.Usr$usrsig' :object '-t $pid'"
        EG "register :name '/$server/SigTask.$TASK.Usr$usrsig' :value '0'"
        after 25
        set RDOUTserver $server
        if {[llength $args] > 1} {wait_for_completion $TASK "[second $args]"} else {wait_for_completion $TASK ""}
    }
}

